%{!?configure_options: %global configure_options %{nil}}
%{!?use_rel: %global use_rel 1}

%{!?make_build: %global make_build %{__make} %{?_smp_mflags} %{?mflags} V=1}

Name: dpcp
Version: 1.0.0
Release: %{use_rel}%{?dist}
Summary: Direct Packet Control Plane (DPCP) is a library to use DevX
%if 0%{?rhl}%{?fedora} == 0
Group: System Environment/Libraries
%endif

License: Proprietary
Url: https://github.com/Mellanox/%{name}
Source0: %{url}/archive/%{version}/%{name}-%{version}.tar.gz
Source1: %{name}-%{version}.tar.gz

%if 0%{?rhl}%{?fedora} == 0
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
%endif

# project currently supports only the following architectures
ExclusiveArch: x86_64 ppc64le ppc64 aarch64

BuildRequires: pkgconfig
BuildRequires: automake
BuildRequires: autoconf
BuildRequires: libtool
BuildRequires: gcc-c++
BuildRequires: rdma-core-devel

%description
Direct Packet Control Plane (DPCP) provides an unified flexible
interface for programming IB devices using DevX.

%prep
%setup -q

%build
if [ ! -e configure ] && [ -e autogen.sh ]; then
    PRJ_RELEASE=%{use_rel} ./autogen.sh
fi

%configure \
           %{?configure_options}
%{make_build}

%install
%if 0%{?rhl}%{?fedora} == 0
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}
%endif

%{make_build} DESTDIR=%{buildroot} install

find $RPM_BUILD_ROOT%{_libdir} -name '*.la' -delete
find $RPM_BUILD_ROOT%{_libdir} -name '*.a' -delete

%clean
%if 0%{?rhl}%{?fedora} == 0
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}
%endif

%files
%{_libdir}/lib%{name}.so*
%{_includedir}/mellanox/dpcp.h
%doc README
%if 0%{?rhel} >= 7 || 0%{?fedora} >= 24 || 0%{?suse_version} >= 1500
%license LICENSE
%endif

%changelog
* Wed Jul 15 2020 Ilan Smith <ilansm@mellanox.com> 1.0.0-1
- Bump version to 1.0.0
* Wed Jul 15 2020 Ilan Smith <ilansm@mellanox.com> 0.1.11-1
- Bump version to 0.1.11
* Fri Jul 10 2020 Ilan Smith <ilansm@mellanox.com> 0.1.10-1
- Bump version to 0.1.10
* Mon Jul 06 2020 Ilan Smith <ilansm@mellanox.com> 0.1.9-1
- Bump version to 0.1.9
* Fri Jul 03 2020 Ilan Smith <ilansm@mellanox.com> 0.1.8-1
- Bump version to 0.1.8
* Thu Jul 02 2020 Ilan Smith <ilansm@mellanox.com> 0.1.7-1
- Bump version to 0.1.7
* Thu Jun 18 2020 Ilan Smith <ilansm@mellanox.com> 0.1.6-1
- Bump version to 0.1.6
* Mon Jun 15 2020 Ilan Smith <ilansm@mellanox.com> 0.1.5-1
- Bump version to 0.1.5
* Mon Jun 08 2020 Ilan Smith <ilansm@mellanox.com> 0.1.4-1
- Bump version to 0.1.4
* Thu Jun 04 2020 Ilan Smith <ilansm@mellanox.com> 0.1.3-1
- Bump version to 0.1.3
* Wed May 27 2020 Ilan Smith <ilansm@mellanox.com> 0.1.2-1
- Bump version to 0.1.2
* Tue May 12 2020 Ilan Smith <ilansm@mellanox.com> 0.1.1-1
- Bump version to 0.1.1
* Wed May 6 2020 Igor Ivanov <igori@mellanox.com> 0.1.0-1
- Initial Packaging
